commit d97dbf60dda22e0668dc33ca3a536adcb0963a65
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Thu Oct 14 20:18:14 2021

    Fortran: fix order of checks for the SHAPE intrinsic
    
    gcc/fortran/ChangeLog:
    
            PR fortran/102716
            * check.c (gfc_check_shape): Reorder checks so that invalid KIND
            arguments can be detected.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/102716
            * gfortran.dg/shape_10.f90: New test.
    
    (cherry picked from commit 1b115daf62d94337b3d0b2962b0bbbf005a450e0)

diff --git a/gcc/testsuite/gfortran.dg/shape_10.f90 b/gcc/testsuite/gfortran.dg/shape_10.f90
new file mode 100644
index 00000000000..4943c21b1d2
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/shape_10.f90
@@ -0,0 +1,6 @@
+! { dg-do compile }
+! PR fortran/102716
+
+program p
+  integer, parameter :: a(1) = shape([2], [1]) ! { dg-error "must be a scalar" }
+end

